DeckLinkInputDelegate Class Reference

Implementation of the Blackmagic Decklink API (used by the DecklinkReader) More...

`#include <DecklinkInput.h>`

Inheritance diagram for DeckLinkInputDelegate:

## Public Member Functions

virtual ULONG STDMETHODCALLTYPE | AddRef (void)
| DeckLinkInputDelegate (pthread_cond_t *m_sleepCond, IDeckLinkOutput *deckLinkOutput, IDeckLinkVideoConversion *deckLinkConverter)
unsigned long | GetCurrentFrameNumber ()
std::shared_ptr< openshot::Frame > | GetFrame (int64_t requested_frame)
virtual HRESULT STDMETHODCALLTYPE | QueryInterface (REFIID iid, LPVOID *ppv)
virtual ULONG STDMETHODCALLTYPE | Release (void)
virtual HRESULT STDMETHODCALLTYPE | VideoInputFormatChanged (BMDVideoInputFormatChangedEvents, IDeckLinkDisplayMode *, BMDDetectedVideoInputFormatFlags)
virtual HRESULT STDMETHODCALLTYPE | VideoInputFrameArrived (IDeckLinkVideoInputFrame *, IDeckLinkAudioInputPacket *)
| ~DeckLinkInputDelegate ()

## Public Attributes

IDeckLinkVideoConversion * | deckLinkConverter
IDeckLinkOutput * | deckLinkOutput
unsigned long | final_frameCount
openshot::CacheMemory | final_frames
unsigned long | frameCount
BMDTimecodeFormat | g_timecodeFormat
std::deque< IDeckLinkMutableVideoFrame * > | raw_video_frames
pthread_cond_t * | sleepCond

## Detailed Description

Implementation of the Blackmagic Decklink API (used by the DecklinkReader)

Definition at line 73 of file DecklinkInput.h.

## Constructor & Destructor Documentation

## DeckLinkInputDelegate()

DeckLinkInputDelegate::DeckLinkInputDelegate | ( | pthread_cond_t * | m_sleepCond,
|  | IDeckLinkOutput * | deckLinkOutput,
|  | IDeckLinkVideoConversion * | deckLinkConverter
| ) |  |

Definition at line 60 of file DecklinkInput.cpp.

## ~DeckLinkInputDelegate()

DeckLinkInputDelegate::~DeckLinkInputDelegate | ( |  | ) |

Definition at line 73 of file DecklinkInput.cpp.

## Member Function Documentation

## AddRef()

ULONG DeckLinkInputDelegate::AddRef | ( | void |  | ) |

virtual

Definition at line 78 of file DecklinkInput.cpp.

## GetCurrentFrameNumber()

unsigned long DeckLinkInputDelegate::GetCurrentFrameNumber | ( |  | ) |

Definition at line 102 of file DecklinkInput.cpp.

Referenced by openshot::DecklinkReader::GetCurrentFrameNumber(), and GetFrame().

## GetFrame()

std::shared_ptr< openshot::Frame > DeckLinkInputDelegate::GetFrame | ( | int64_t | requested_frame | ) |

Definition at line 110 of file DecklinkInput.cpp.

Referenced by openshot::DecklinkReader::GetFrame().

## QueryInterface()

virtual HRESULT STDMETHODCALLTYPE DeckLinkInputDelegate::QueryInterface | ( | REFIID | iid,
|  | LPVOID * | ppv
| ) |  |

inline virtual

Definition at line 92 of file DecklinkInput.h.

## Release()

ULONG DeckLinkInputDelegate::Release | ( | void |  | ) |

virtual

Definition at line 87 of file DecklinkInput.cpp.

## VideoInputFormatChanged()

HRESULT DeckLinkInputDelegate::VideoInputFormatChanged | ( | BMDVideoInputFormatChangedEvents | events,
|  | IDeckLinkDisplayMode * | mode,
|  | BMDDetectedVideoInputFormatFlags |
| ) |  |

virtual

Definition at line 288 of file DecklinkInput.cpp.

## VideoInputFrameArrived()

HRESULT DeckLinkInputDelegate::VideoInputFrameArrived | ( | IDeckLinkVideoInputFrame * | videoFrame,
|  | IDeckLinkAudioInputPacket * | audioFrame
| ) |  |

virtual

Definition at line 138 of file DecklinkInput.cpp.

## Member Data Documentation

## deckLinkConverter

IDeckLinkVideoConversion* DeckLinkInputDelegate::deckLinkConverter

Definition at line 87 of file DecklinkInput.h.

Referenced by DeckLinkInputDelegate(), and VideoInputFrameArrived().

## deckLinkOutput

IDeckLinkOutput* DeckLinkInputDelegate::deckLinkOutput

Definition at line 86 of file DecklinkInput.h.

Referenced by DeckLinkInputDelegate(), and VideoInputFrameArrived().

## final_frameCount

unsigned long DeckLinkInputDelegate::final_frameCount

Definition at line 79 of file DecklinkInput.h.

Referenced by GetCurrentFrameNumber(), and VideoInputFrameArrived().

## final_frames

openshot::CacheMemory DeckLinkInputDelegate::final_frames

Definition at line 83 of file DecklinkInput.h.

Referenced by DeckLinkInputDelegate(), GetFrame(), and VideoInputFrameArrived().

## frameCount

unsigned long DeckLinkInputDelegate::frameCount

Definition at line 78 of file DecklinkInput.h.

Referenced by VideoInputFrameArrived().

## g_timecodeFormat

BMDTimecodeFormat DeckLinkInputDelegate::g_timecodeFormat

Definition at line 77 of file DecklinkInput.h.

Referenced by VideoInputFrameArrived().

## raw_video_frames

std::deque<IDeckLinkMutableVideoFrame*> DeckLinkInputDelegate::raw_video_frames

Definition at line 82 of file DecklinkInput.h.

Referenced by VideoInputFrameArrived().

## sleepCond

pthread_cond_t* DeckLinkInputDelegate::sleepCond

Definition at line 76 of file DecklinkInput.h.

Referenced by DeckLinkInputDelegate().

The documentation for this class was generated from the following files:

- DecklinkInput.h
- DecklinkInput.cpp